----------------------------------------------------------------------------
-- Script: 	Oscillator
-- Version:	1.1
-- Last update: 18.12.2002
-- By:     	Adam Wierzchowski
-- Web:		www.asd.3D.pl
-- E-mail: 	asd@grafik.3D.pl
--
-- Edited by: Antoine Pasquay
-- web : www.athanaze.com
-- E-mail: athanaze@fr.st
--
-- Add  : reduce Key
--		: undoable
----------------------------------------------------------------------------
-- If You create something interesting with one of my scripts,
-- please mail it to me and I will place it on my web site as an example.
---------------------------------------------------------------------re-------

global animated_obj
global current_controller

rollout about_roll "About" rolledup:true
(
label lab1_ab "Oscillator 1.1"
label lab2_ab "by Adam Wierzchowski"
label lab3_ab "E-mail: asd@grafik.3D.pl"
label lab4_ab "Web: www.asd.3D.pl"
label lab5_ab "Edited by Antoine Pasquay"
)

rollout obj_set "Object settings" rolledup:false
(
pickbutton pick_obj "Select object" 
label obj_name "Selected object: none"

on pick_obj picked obj do
(
animated_obj = obj
obj_name.text = "Selected object: " + animated_obj.name
)

)

rollout imp_set "Impulse settings" rolledup:true
(
label lab_info1 "ATTENTION: Results will be" align:#left
label lab_info2 "visible only if damping enabled" align:#left
group "Impulse every Nth frame"
	(
	checkbox impnth "Enable"
	spinner nth_spinner "Nth frame: " type:#integer range:[1,100,30] fieldwidth:59 enabled:false
	checkbox cons_phase "Consider phase shift" enabled:false
	)
group "Impulse at random frame"
	(
	checkbox imprandom "Enable" align:#left
	spinner random_spinner "Propability: " type:#float range:[0,1,0.03] scale:0.001 fieldwidth:59 enabled:false
	checkbox at_mult "Only at multiple of (period/2)" enabled:false
	)

on impnth changed state do
(
if state == true then
	(
	if imprandom.state == true then imprandom.state = false
	random_spinner.enabled = false
	at_mult.enabled = false
	nth_spinner.enabled = true
	cons_phase.enabled = true
	)
	else
	(
	nth_spinner.enabled = false
	cons_phase.enabled = false
	)
)

on imprandom changed state do
(
if state == true then
	(
	if impnth.state == true then impnth.state = false
	nth_spinner.enabled = false
	cons_phase.enabled = false
	random_spinner.enabled = true
	at_mult.enabled = true
	)
else
	(
	random_spinner.enabled = false
	at_mult.enabled = false
	)
)

)
	
rollout osc_set "Oscillation settings" rolledup:false
(
spinner osc_start "Start frame: " type:#integer range:[0,1000,0] fieldwidth:59
spinner osc_end "End frame: " type:#integer range:[1,1000,100] fieldwidth:59
label lab_osc_type "Oscilliation type: " across:2
radiobuttons osc_type labels:#("Position","Rotation") across:1
label lab_osc_axis "Oscilliation axis: " across:2
radiobuttons osc_axis labels:#("X","Y","Z") across:1 offset:[-16,0]
spinner period_spinner "Period: " type:#integer range:[1,500,30] fieldwidth:59
spinner amplitude_spinner "Amplitude: " type:#integer range:[1,500,100] fieldwidth:59
spinner phase_spinner "Phase: " type:#integer range:[0,500,0] fieldwidth:59
)
	
rollout damp_set "Damping settings" rolledup:true
(
checkbox damp_enable "Enable damping"
label lab_damp_type "Damping type: " across:2
radiobuttons damp_type labels:#("Linear","Exp","Log") across:1 offset:[-5,0]
spinner damp_spinner "Hold after: " type:#integer range:[1,100,30] fieldwidth:59
)

rollout act "Action" rolledup:false
(
checkbox reduc_key "Reduce Keys" width:140 checked: true
spinner treshold "Treshold:" range:[0,1000,1] align:#right
label lab_frame "Current frame:"
label lab_prog "Done:"
button go "Create keys"

on go pressed do
(
undo "Ocsillator" on
(
local obj_oryg_pos
local imp_control = 0
case osc_set.osc_type.state of
	(
	1:	(
		animated_obj.pos.controller = Position_XYZ()
		case osc_set.osc_axis.state of
			(
			1:	(
				animated_obj.pos.Xposition.controller = Bezier_Float()
				current_controller = animated_obj.pos.Xposition.controller
				obj_oryg_pos = animated_obj.pos.x
				) 
			2:	(
				animated_obj.pos.Yposition.controller = Bezier_Float()
				current_controller = animated_obj.pos.Yposition.controller
				obj_oryg_pos = animated_obj.pos.y
				)
			3:	(
				animated_obj.pos.Zposition.controller = Bezier_Float()
				current_controller = animated_obj.pos.Zposition.controller
				obj_oryg_pos = animated_obj.pos.z
				)
			)
		)
	2:	(
		animated_obj.rotation.controller = Euler_XYZ()
		case osc_set.osc_axis.state of
			(
			1:	(
				animated_obj.rotation.Xrotation.controller = Bezier_Float()
				current_controller = animated_obj.rotation.Xrotation.controller
				) 
			2:	(
				animated_obj.rotation.Yrotation.controller = Bezier_Float()
				current_controller = animated_obj.rotation.Yrotation.controller
				)
			3:	(
				animated_obj.rotation.Zrotation.controller = Bezier_Float()
				current_controller = animated_obj.rotation.Zrotation.controller
				)
			)
		)
	)
for i in animationRange.start to animationRange.end do
		(
		key_index = getkeyindex current_controller i
		if (key_index) != 0 then (deleteKey current_controller key_index)
		)
for i in osc_set.osc_start.value to osc_set.osc_end.value do
	(
	current_key = addNewKey current_controller i
	amplitude = osc_set.amplitude_spinner.value * sin((i + osc_set.phase_spinner.value)*360/osc_set.period_spinner.value)
	if damp_set.damp_enable.state == true then
		(
		imp_control += 1
		if (imp_set.impnth.state == true) and (imp_set.cons_phase.state == false) then
			(
			if (mod i (imp_set.nth_spinner.value)) == 0 then imp_control = 1
			)
		if (imp_set.impnth.state == true) and (imp_set.cons_phase.state == true) then
			(
			if (mod (i + osc_set.phase_spinner.value) (imp_set.nth_spinner.value)) == 0 then imp_control = 1
			)
		if (imp_set.imprandom.state == true) and (imp_set.at_mult.state == false) then
			(
			if imp_set.random_spinner.value > (random 0. 1) then imp_control = 1
			)
		if (imp_set.imprandom.state == true) and (imp_set.at_mult.state == true) then
			(
			if (imp_set.random_spinner.value > (random 0. 1)) and (mod (i + osc_set.phase_spinner.value) (osc_set.period_spinner.value / 2)) == 0 then imp_control = 1
			)
		case damp_set.damp_type.state of
			(
			1: (if imp_control < damp_set.damp_spinner.value then damp = (1-(imp_control as float/damp_set.damp_spinner.value)) else damp = 0)
			2: (if imp_control < damp_set.damp_spinner.value then damp = (((damp_set.damp_spinner.value/imp_control as float)-1)/damp_set.damp_spinner.value) else damp = 0)
			3: (if imp_control < damp_set.damp_spinner.value then damp = (((log10 damp_set.damp_spinner.value)-(log10 (imp_control+1)))/(log10 damp_set.damp_spinner.value)) else damp = 0)
			)
		)
		else damp = 1
	case osc_set.osc_type.state of
		(
		1:	(current_key.value = obj_oryg_pos + (amplitude * damp))
		2:	(current_key.value = amplitude * damp)
		)	
	lab_frame.text = "Current frame: " + i as string
	lab_prog.text = "Done: " + ((i-osc_set.osc_start.value) as float/(osc_set.osc_end.value-osc_set.osc_start.value)*100) as string + "%"
	)
)
if reduc_key.checked == true then reduceKeys current_controller treshold.value 1f osc_set.osc_start.value osc_set.osc_end.value
)
)

mainfloater = newRolloutFloater "Oscillator" 201 528
addrollout about_roll mainfloater
addrollout obj_set mainfloater
addrollout imp_set mainfloater
addrollout osc_set mainfloater
addrollout damp_set mainfloater
addrollout act mainfloater